//---------------------------------------------------------------------------


#pragma hdrstop

#include <fstream>
#include <cstring>
#include "BaseAcordes.h"


BaseAcordes::BaseAcordes(const char *nomeArquivo) {
   ifstream in(nomeArquivo);

   if(!in.is_open()) {
      throw nomeArquivo;
   }

   while(!in.eof()) {
      Acorde *acorde = new Acorde;
      char *nome = new char[10], c;
      int temp, aspas = 0, index = 0;

      /*
       * pega o nome do acorde
       */
      while(aspas != 2) {
         if((c = in.get()) == '\"') {
            aspas++;
         } else if(aspas){
            nome[index++] = c;
         }
      }
      nome[index] = '\0';
      /*seta o nome*/
      acorde->setNome(nome);

      for(int i=0;i<6;i++) {
         Acorde::Corda corda;
         in >> corda.casa >> corda.dedoMaoDir >> corda.dedoMaoEsq;
         acorde->setCorda(i, corda);
      }

      in >> temp;
      acorde->setFacilidade(temp);
      in >> temp;
      acorde->setFlexibilidade(temp);
      in >> temp;
      acorde->setFrequenciaUso(temp);
      in >> temp;
      acorde->setSonoridade(temp);
      inserir(acorde);
   }
   in.close();
}

BaseAcordes::~BaseAcordes() {}

list<Acorde*>& BaseAcordes::getAcordes(string nome) {
   pair<multimap<string,Acorde*>::iterator,
        multimap<string,Acorde*>::iterator> p = this->base.equal_range(nome);
   list<Acorde*> *retorno = new list<Acorde*>;

   multimap<string,Acorde*>::iterator i = p.first;
   while(i != p.second) {
      retorno->push_back((*i).second);
      i++;
   }
   return *retorno;
}

void BaseAcordes::inserir(Acorde *acorde){
   typedef multimap<string,Acorde*>::value_type value_type;
   this->base.insert(value_type(acorde->getNome(), acorde));
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
