//---------------------------------------------------------------------------


#pragma hdrstop

#include "MAcorde.h"


Acorde::Acorde() {}

Acorde::Acorde(const Acorde& acorde) {
   *this = acorde;
}

Acorde::~Acorde() {}

void Acorde::setCorda(unsigned index, const Corda& corda) {
   if(index < 6)
      this->cordas[index] = corda;
}

Acorde::Corda Acorde::getCorda(unsigned index) const {
   if(index < 6)
      return this->cordas[index];
   else {
      throw index;
   }
}

void Acorde::setNome(string nome) {
   this->nome = nome;
}

string Acorde::getNome() const{
   return this->nome;
}

Acorde& Acorde::operator = (const Acorde& acorde) {
   this->nome = acorde.nome;
   for(int i = 0; i < 6; i++) {
      this->cordas[i] = acorde.cordas[i];
   }
   return *this;
}

int Acorde::getFacilidade() const {
   return this->facilidade;
}

void Acorde::setFacilidade(int facilidade) {
   this->facilidade = facilidade;
}

int Acorde::getFlexibilidade() const {
   return this->flexibilidade;
}

void Acorde::setFlexibilidade(int flexibilidade) {
   this->flexibilidade = flexibilidade;
}

int Acorde::getFrequenciaUso() const {
   return this->frequenciaUso;
}

void Acorde::setFrequenciaUso(int frequenciaUso) {
   this->frequenciaUso = frequenciaUso;
}

int Acorde::getSonoridade() const {
   return this->sonoridade;
}

void Acorde::setSonoridade(int sonoridade) {
   this->sonoridade = sonoridade;
}

string Acorde::toString() const {
   string retorno = "\"";
   char buf[15];
   retorno += this->nome + "\"\n";
   for(int i=0;i<6;i++) {
      retorno += itoa(this->cordas[i].casa, buf, 10);
      retorno += " ";
      retorno += itoa(this->cordas[i].dedoMaoDir, buf, 10);
      retorno += " ";
      retorno += itoa(this->cordas[i].dedoMaoEsq, buf, 10);
      retorno += "\n";
   }
   retorno += itoa(this->facilidade, buf, 10);
   retorno += "\n";
   retorno += itoa(this->flexibilidade, buf, 10);
   retorno += "\n";
   retorno += itoa(this->frequenciaUso, buf, 10);
   retorno += "\n";
   retorno += itoa(this->sonoridade, buf, 10);
   return retorno;
}

//---------------------------------------------------------------------------

#pragma package(smart_init)
